	cpu LMM
	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
;          iData -> X+0
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 9
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; 
; void RED_LED(void);
; void BLUE_LED(void);
; void GREEN_LED(void);
; 
; void main()
; {
	.dbline 12
; 
;  	int iData; 		
;  	PWM16_1_Start();								// PWM16 Start
	push X
	xcall _PWM16_1_Start
	pop X
	.dbline 13
;  	M8C_EnableGInt;									// Global Interrupt Enable
		or  F, 01h

	.dbline 14
;    	ADC10_1_Start(ADC10_1_LOWRANGE);				// ADC10 UM Start
	push X
	mov A,1
	xcall _ADC10_1_Start
	.dbline 16
; //	ADC10_1_iCal(0x22A, ADC10_1_CAL_VBG);  			// use internal reference	
; 	ADC10_1_iCal(0x3FF, ADC10_1_CAL_P0_7);  		// use external reference
	mov A,-109
	push A
	mov A,3
	push A
	mov A,-1
	push A
	xcall _ADC10_1_iCal
	mov REG[0xd0],>__r0
	add SP,-3
	.dbline 20
; 													// if you want to use external reference. please modify adc10xx.asm
; 													// in function 'ADC10_xxiCal'
; 													// tst   [X + RefSelect],0h --> tst   [X + RefSelect],80h   
;    	ADC10_1_StartADC();								// ADC Start
	xcall _ADC10_1_StartADC
	.dbline 21
;    	PWM16_1_WritePeriod(341);	
	mov X,1
	mov A,85
	xcall _PWM16_1_WritePeriod
	pop X
	xjmp L3
X0:
	.dbline 22
;    	while(1){   			
L5:
	.dbline 23
L6:
	.dbline 23
;         		while(0 == ADC10_1_fIsDataAvailable());    	
	push X
	xcall _ADC10_1_fIsDataAvailable
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L5
	.dbline 24
;         		iData = ADC10_1_iGetDataClearFlag();    	
	push X
	xcall _ADC10_1_iGetDataClearFlag
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 26
; 				
; 				if(iData<341)
	mov A,[X+1]
	sub A,85
	mov A,[X+0]
	xor A,-128
	sbb A,(1 ^ 0x80)
	jnc L8
X2:
	.dbline 27
;  				{	
	.dbline 28
;  					PWM16_1_Stop();
	push X
	xcall _PWM16_1_Stop
	pop X
	.dbline 29
;  					RED_LED();
	xcall _RED_LED
	.dbline 30
;  					PWM16_1_WritePulseWidth(iData);
	push X
	mov A,[X+0]
	push A
	mov A,[X+1]
	pop X
	xcall _PWM16_1_WritePulseWidth
	.dbline 31
;  					PWM16_1_Start();
	xcall _PWM16_1_Start
	pop X
	.dbline 32
;  				}
L8:
	.dbline 34
;  				
;  				if(iData>341 && iData <682)
	mov A,85
	sub A,[X+1]
	mov A,[X+0]
	xor A,-128
	mov REG[0xd0],>__r0
	mov [__rX],A
	mov A,(1 ^ 0x80)
	sbb A,[__rX]
	jnc L10
X3:
	mov A,[X+1]
	sub A,-86
	mov A,[X+0]
	xor A,-128
	sbb A,(2 ^ 0x80)
	jnc L10
X4:
	.dbline 35
;  				{
	.dbline 37
;  				 	
;  					PWM16_1_Stop();
	push X
	xcall _PWM16_1_Stop
	pop X
	.dbline 38
;  					GREEN_LED();
	xcall _GREEN_LED
	.dbline 39
;  					PWM16_1_WritePulseWidth(iData-341);
	mov REG[0xd0],>__r0
	mov A,[X+1]
	sub A,85
	mov [__r1],A
	mov A,[X+0]
	sbb A,1
	push X
	push A
	mov A,[__r1]
	pop X
	xcall _PWM16_1_WritePulseWidth
	.dbline 40
;  					PWM16_1_Start();
	xcall _PWM16_1_Start
	pop X
	.dbline 42
;  
;  				}
L10:
	.dbline 44
;  				
;  				if(iData>682)
	mov A,-86
	sub A,[X+1]
	mov A,[X+0]
	xor A,-128
	mov REG[0xd0],>__r0
	mov [__rX],A
	mov A,(2 ^ 0x80)
	sbb A,[__rX]
	jnc L12
X5:
	.dbline 45
;  				{
	.dbline 47
;  				 	
;  					PWM16_1_Stop();
	push X
	xcall _PWM16_1_Stop
	pop X
	.dbline 48
;  					BLUE_LED();
	xcall _BLUE_LED
	.dbline 49
;  					PWM16_1_WritePulseWidth(iData-682);
	mov REG[0xd0],>__r0
	mov A,[X+1]
	sub A,-86
	mov [__r1],A
	mov A,[X+0]
	sbb A,2
	push X
	push A
	mov A,[__r1]
	pop X
	xcall _PWM16_1_WritePulseWidth
	.dbline 50
;  					PWM16_1_Start();
	xcall _PWM16_1_Start
	pop X
	.dbline 52
;  
;  				}
L12:
	.dbline 54
L3:
	.dbline 22
	xjmp L6
X1:
	.dbline -2
	.dbline 55
; 
;  		}
; }
L1:
	add SP,-2
	pop X
	.dbline 0 ; func end
	jmp .
	.dbsym l iData 0 I
	.dbend
	.dbfunc e RED_LED _RED_LED fV
_RED_LED::
	.dbline -1
	.dbline 58
; 
; 	void RED_LED(void)				//connect to Red LED 
; 	{
	.dbline 59
; 	 	DCB02CR0 = 0x00;
	mov REG[0x2b],0
	.dbline 60
; 	 	DCB02OU &= 0xF8;
	or F,0x10  ; iopage = 1
	and REG[0x2a],-8
	and F,0xEF ; iopage = 0
	.dbline 61
; 		DCB02OU |= 0x07;  
	or F,0x10  ; iopage = 1
	or REG[0x2a],7
	and F,0xEF ; iopage = 0
	.dbline 62
; 		DCB02CR0 = 0x01;
	mov REG[0x2b],1
	.dbline 63
; 		PRT1GS = 0x08;
	mov REG[0x6],8
	.dbline -2
	.dbline 64
; 	}
L14:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e BLUE_LED _BLUE_LED fV
_BLUE_LED::
	.dbline -1
	.dbline 67
; 	
; 	void BLUE_LED(void)				//connect to Blue LED 
; 	{
	.dbline 68
; 	 	DCB02CR0 = 0x00;
	mov REG[0x2b],0
	.dbline 69
; 	 	DCB02OU &= 0xF8;
	or F,0x10  ; iopage = 1
	and REG[0x2a],-8
	and F,0xEF ; iopage = 0
	.dbline 70
; 		DCB02OU |= 0x06;  
	or F,0x10  ; iopage = 1
	or REG[0x2a],6
	and F,0xEF ; iopage = 0
	.dbline 71
; 		DCB02CR0 = 0x01;
	mov REG[0x2b],1
	.dbline 72
; 		PRT1GS = 0x04;
	mov REG[0x6],4
	.dbline -2
	.dbline 73
; 	}
L15:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e GREEN_LED _GREEN_LED fV
_GREEN_LED::
	.dbline -1
	.dbline 76
; 	
; 	void GREEN_LED(void)			//connect to Green LED 
; 	{
	.dbline 77
; 	 	DCB02CR0 = 0x00;
	mov REG[0x2b],0
	.dbline 78
; 	 	DCB02OU &= 0xF8;
	or F,0x10  ; iopage = 1
	and REG[0x2a],-8
	and F,0xEF ; iopage = 0
	.dbline 79
; 		DCB02OU |= 0x04;  
	or F,0x10  ; iopage = 1
	or REG[0x2a],4
	and F,0xEF ; iopage = 0
	.dbline 80
; 		DCB02CR0 = 0x01;
	mov REG[0x2b],1
	.dbline 81
; 		PRT1GS = 0x10;
	mov REG[0x6],16
	.dbline -2
	.dbline 82
; 	}
L16:
	.dbline 0 ; func end
	ret
	.dbend
