	cpu LMM
	.module main.c
	.area data(ram, con, rel)
_A::
	.word 0x3aa9,0xf100
	.dbfile ./main.c
	.dbsym e A _A D
	.area data(ram, con, rel)
	.dbfile ./main.c
	.area data(ram, con, rel)
	.dbfile ./main.c
_B::
	.word 0x3959,0x9b9b
	.dbsym e B _B D
	.area data(ram, con, rel)
	.dbfile ./main.c
	.area data(ram, con, rel)
	.dbfile ./main.c
_C::
	.word 0x343e,0xa825
	.dbsym e C _C D
	.area data(ram, con, rel)
	.dbfile ./main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
;         Result -> X+2
;          iData -> X+0
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,6
	.dbline 13
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; #include <math.h>
; #include <stdlib.h>
; 
; float iData_to_Temp(float iData);
; 
; float A=0.00129655;
; float B=0.000207527;
; float C=0.000000177563;
; 
; 	void main()
; 	{
	.dbline 17
; 	 	int iData; 												// AD buffer
; 	 	float Result;											// temperature buffer	
; 	 	///UM Configration///			
; 	 	M8C_EnableGInt;    			
		or  F, 01h

	.dbline 18
; 	   	ADC10_1_Start(ADC10_1_LOWRANGE);     	
	push X
	mov A,1
	xcall _ADC10_1_Start
	.dbline 19
; 	   	ADC10_1_iCal(0x22A, ADC10_1_CAL_VBG);  					// use internal reference	
	mov A,3
	push A
	mov A,2
	push A
	mov A,42
	push A
	xcall _ADC10_1_iCal
	mov REG[0xd0],>__r0
	add SP,-3
	.dbline 25
; //	   	ADC10_1_iCal(0x3FF, ADC10_1_CAL_P0_7);  				// use external reference
; 																// if you want to use external reference. please modify adc10xx.asm
; 																// in function 'ADC10_xxiCal'
; 																// tst   [X + RefSelect],0h --> tst   [X + RefSelect],80h   
; 
; 	   	ADC10_1_StartADC();     
	xcall _ADC10_1_StartADC
	.dbline 26
; 	   	TX8_Start(TX8_PARITY_NONE);  
	mov A,0
	xcall _TX8_Start
	pop X
	xjmp L3
X0:
	.dbline 28
; 	   	          			
; 	   	while(1){   
L5:
	.dbline 29
L6:
	.dbline 29
	push X
	xcall _ADC10_1_fIsDataAvailable
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L5
	.dbline 30
	push X
	xcall _ADC10_1_iGetDataClearFlag
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 31
	mov A,[X+1]
	mov [__r3],A
	mov A,[X+0]
	mov [__r2],A
	tst [__r2],-128
	jz X2
	mov [__r1],-1
	mov [__r0],-1
	jmp X3
X2:
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
X3:
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __long2fp
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall _iData_to_Temp
	add SP,-4
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov [X+2],A
	mov A,[__r1]
	mov [X+3],A
	mov A,[__r2]
	mov [X+4],A
	mov A,[__r3]
	mov [X+5],A
	.dbline 32
	push X
	mov A,>L8
	push A
	mov A,<L8
	mov X,A
	pop A
	xcall _TX8_CPutString
	.dbline 33
	mov A,>L9
	push A
	mov A,<L9
	mov X,A
	pop A
	xcall _TX8_CPutString
	pop X
	.dbline 34
	mov A,0
	push A
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	mov A,[X+4]
	push A
	mov A,[X+5]
	push A
	xcall _ftoa
	add SP,-6
	push X
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _TX8_PutString
	.dbline 35
	mov A,>L10
	push A
	mov A,<L10
	mov X,A
	pop A
	xcall _TX8_CPutString
	pop X
	.dbline 36
L3:
	.dbline 28
	xjmp L6
X1:
	.dbline -2
	.dbline 37
; 					while(0 == ADC10_1_fIsDataAvailable());    
; 			        iData = ADC10_1_iGetDataClearFlag();  
; 					Result=iData_to_Temp(iData);				// calc temperature
; 					TX8_CPutString("\r\n");
; 					TX8_CPutString("Temperature=");
; 					TX8_PutString(ftoa(Result,0));				// output temperature 
; 					TX8_CPutString("[K]\r\n");
; 		 		}
; 	}
L1:
	add SP,-6
	pop X
	.dbline 0 ; func end
	jmp .
	.dbsym l Result 2 D
	.dbsym l iData 0 I
	.dbend
	.dbfunc e iData_to_Temp _iData_to_Temp fD
;              T -> X+4
;              R -> X+0
;          iData -> X-7
_iData_to_Temp::
	.dbline -1
	push X
	mov X,SP
	add SP,20
	.dbline 40
; 	//calc temperature//
; 	float iData_to_Temp(float iData)
; 	{	
	.dbline 43
; 			float T,R;
; 
; 	 		R=(iData*10000.0)/(1023-iData);		
	mov REG[0xd0],>__r0
	mov A,[X-7]
	push A
	mov A,[X-6]
	push A
	mov A,[X-5]
	push A
	mov A,[X-4]
	push A
	mov A,68
	push A
	mov A,127
	push A
	mov A,-64
	push A
	mov A,0
	push A
	xcall __fpsub
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,[X-7]
	push A
	mov A,[X-6]
	push A
	mov A,[X-5]
	push A
	mov A,[X-4]
	push A
	mov A,70
	push A
	mov A,28
	push A
	mov A,64
	push A
	mov A,0
	push A
	xcall __fpmul
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	add SP,-4
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __fpdiv
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-4
	.dbline 44
; 	 		T=(float)1.0/(A+(B)*log(R)+C*(log(R))*(log(R))*(log(R)));
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall _log
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov [X+8],A
	mov A,[__r1]
	mov [X+9],A
	mov A,[__r2]
	mov [X+10],A
	mov A,[__r3]
	mov [X+11],A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall _log
	add SP,-8
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov [X+12],A
	mov A,[__r1]
	mov [X+13],A
	mov A,[__r2]
	mov [X+14],A
	mov A,[__r3]
	mov [X+15],A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall _log
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov [X+16],A
	mov A,[__r1]
	mov [X+17],A
	mov A,[__r2]
	mov [X+18],A
	mov A,[__r3]
	mov [X+19],A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall _log
	add SP,-8
	mov REG[0xd0],>_C
	mov A,[X+12]
	push A
	mov A,[X+13]
	push A
	mov A,[X+14]
	push A
	mov A,[X+15]
	push A
	mov A,[_C]
	push A
	mov A,[_C+1]
	push A
	mov A,[_C+2]
	push A
	mov A,[_C+3]
	push A
	mov REG[0xd0],>__r0
	xcall __fpmul
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	add SP,-4
	mov A,[X+16]
	push A
	mov A,[X+17]
	push A
	mov A,[X+18]
	push A
	mov A,[X+19]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __fpmul
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	add SP,-4
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __fpmul
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov REG[0xd0],>_B
	mov A,[X+8]
	push A
	mov A,[X+9]
	push A
	mov A,[X+10]
	push A
	mov A,[X+11]
	push A
	mov A,[_B]
	push A
	mov A,[_B+1]
	push A
	mov A,[_B+2]
	push A
	mov A,[_B+3]
	push A
	mov REG[0xd0],>__r0
	xcall __fpmul
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	add SP,-4
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov REG[0xd0],>_A
	mov A,[_A]
	push A
	mov A,[_A+1]
	push A
	mov A,[_A+2]
	push A
	mov A,[_A+3]
	push A
	mov REG[0xd0],>__r0
	xcall __fpadd
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	add SP,-4
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __fpadd
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	add SP,-4
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,63
	push A
	mov A,-128
	push A
	mov A,0
	push A
	push A
	xcall __fpdiv
	pop A
	mov [X+7],A
	pop A
	mov [X+6],A
	pop A
	mov [X+5],A
	pop A
	mov [X+4],A
	add SP,-4
	.dbline 45
; 	 		return T;
	mov A,[X+4]
	mov [__r0],A
	mov A,[X+5]
	mov [__r1],A
	mov A,[X+6]
	mov [__r2],A
	mov A,[X+7]
	mov [__r3],A
	.dbline -2
L11:
	add SP,-20
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l T 4 D
	.dbsym l R 0 D
	.dbsym l iData -7 D
	.dbend
	.area lit(rom, con, rel)
L10:
	.byte 91,'K,93,13,10,0
L9:
	.byte 'T,'e,'m,'p,'e,'r,'a,'t,'u,'r,'e,61,0
L8:
	.byte 13,10,0
