#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules


void main()
{
 	int iData;
	PWM16_1_WritePeriod(65535);						//Pulse Frequency Set
 	PWM16_1_Start();								//PWM Start
 	M8C_EnableGInt;									//Global Interruput Enable
	ADC10_1_Start(ADC10_1_LOWRANGE);     			//ADC UM Start
	ADC10_1_iCal(0x22A, ADC10_1_CAL_VBG);  			// use internal reference	
//	ADC10_1_iCal(0x3FF, ADC10_1_CAL_P0_7);  		// use external reference
													// if you want to use external reference. please modify adc10xx.asm
													// in function 'ADC10_xxiCal'
													// tst   [X + RefSelect],0h --> tst   [X + RefSelect],80h   
   	ADC10_1_StartADC();                 			//ADC Start
	while(1)
		{   
		while(0 == ADC10_1_fIsDataAvailable());   
		iData = ADC10_1_iGetDataClearFlag();    
		PWM16_1_WritePulseWidth(iData<<6);			//PWM duty set
		}
}
