	cpu LMM
	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
;          iData -> X+0
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 6
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; 
; 
; void main()
; {
	.dbline 8
;  	int iData;
; 	PWM16_1_WritePeriod(65535);						//Pulse Frequency Set
	push X
	mov A,-1
	mov X,A
	xcall _PWM16_1_WritePeriod
	.dbline 9
;  	PWM16_1_Start();								//PWM Start
	xcall _PWM16_1_Start
	pop X
	.dbline 10
;  	M8C_EnableGInt;									//Global Interruput Enable
		or  F, 01h

	.dbline 11
; 	ADC10_1_Start(ADC10_1_LOWRANGE);     			//ADC UM Start
	push X
	mov A,1
	xcall _ADC10_1_Start
	.dbline 12
; 	ADC10_1_iCal(0x22A, ADC10_1_CAL_VBG);  			// use internal reference	
	mov A,3
	push A
	mov A,2
	push A
	mov A,42
	push A
	xcall _ADC10_1_iCal
	mov REG[0xd0],>__r0
	add SP,-3
	.dbline 17
; //	ADC10_1_iCal(0x3FF, ADC10_1_CAL_P0_7);  		// use external reference
; 													// if you want to use external reference. please modify adc10xx.asm
; 													// in function 'ADC10_xxiCal'
; 													// tst   [X + RefSelect],0h --> tst   [X + RefSelect],80h   
;    	ADC10_1_StartADC();                 			//ADC Start
	xcall _ADC10_1_StartADC
	pop X
	xjmp L3
X0:
	.dbline 19
; 	while(1)
; 		{   
L5:
	.dbline 20
L6:
	.dbline 20
	push X
	xcall _ADC10_1_fIsDataAvailable
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L5
	.dbline 21
	push X
	xcall _ADC10_1_iGetDataClearFlag
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 22
	mov A,[X+1]
	mov [__r1],A
	mov A,[X+0]
	mov [__r0],A
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	push X
	mov A,[__r0]
	push A
	mov A,[__r1]
	pop X
	xcall _PWM16_1_WritePulseWidth
	pop X
	.dbline 23
L3:
	.dbline 18
	xjmp L6
X1:
	.dbline -2
	.dbline 24
; 		while(0 == ADC10_1_fIsDataAvailable());   
; 		iData = ADC10_1_iGetDataClearFlag();    
; 		PWM16_1_WritePulseWidth(iData<<6);			//PWM duty set
; 		}
; }
L1:
	add SP,-2
	pop X
	.dbline 0 ; func end
	jmp .
	.dbsym l iData 0 I
	.dbend
